#ifdef DREAMCAST
#include <dcalleg.h>
#endif

#include <allegro.h>
#include "VarGlob.h"
#include "jeu.h"
#include "map.h"
#include "Menu_Jeu.h"
#include "trajectoire.h"
#include "BarreEtAffg.h"
#include "dynamique.h"

#include "menu.h"
#include "bonus.h"
#include "sonore.h"

/*Variable Globale au programme*/
extern int balle_en_attente ;
extern BITMAP *buffer;
extern int position; 
extern int taille_ecran_largeur;
extern int largeur_curseur;
extern int vies;
extern int difficulte;
extern int num_level;
extern int NbrBriques;
extern int score;
extern int timer_superballe;
extern int timer_teleportation;
extern int timer_ballepourri;
extern int timer_finniveau;
extern DATAFILE *fichierdata;

/*fin variable globale au prog */

//prototype
 void afficher_panneau();
//

/*variable globale au fichier */
 int partie_en_cours = 0;
/*----------------------------*/
void barre_souris(void);

volatile int timer=0;/*Volatile car modifie par dos lui meme(externe au prog) ! */
int premierefois=0;

void incrementer_timer()
{
	timer++;
}
END_OF_FUNCTION(incrementer_timer);



//NOTE: We optimize timers to improve speed on Dreamcast!
//Check tutorial: http://awiki.tomasu.org/index.php?title=Timers

void activation_jeu()
{
if (premierefois==0){
    LOCK_VARIABLE(timer);
    LOCK_FUNCTION(incrementer_timer);
    install_int_ex(incrementer_timer,BPS_TO_TIMER(600));
    premierefois=1;
    }


int sortie = 0 ;
int w=0;
int V=1;
int a=0;
partie_en_cours=1;
if (balle_en_attente!=0)
    {
      while (!(sortie==1)) 
           {
            //New code!!!
			while(timer == 0)
            {
                rest(100/600);//rest until a full tick has passed
            }

			while(timer > 0)
            {
				 int oldtimer=timer;
                 bouger_curseur(); //check keyboard
                 w=gerage_balles(0); //checks balls physics
				 timer--;
				 if (oldtimer<=timer) break;
				 al_poll_duh(dp); //playing music
            }
			
			actualiser_map(); //draw updated blocks
			procedure_affichage(); //creates graphics, first time
            
            if (key[KEY_UP] || key[KEY_SPACE] || mouse_b & 1)
               {               
               balle_en_attente=0;
               sortie=1;
               }           
            if  (key[KEY_ESC])
               {
               clear_bitmap(buffer);               
               menu(1,0);        
               sortie=1;               
               }              
           }            
    }
sortie=0; 
if (balle_en_attente==0)
    {
    while (!(sortie==1)) 
    {
        //New code!!!
        while(timer == 0)
        {
            rest(100/600);//rest until a full tick has passed
        }

		while(timer > 0)
        {

		int oldtimer=timer;
        V=vitesse;
        a++;     
        int j;
         for (j=1; j<= 4; j++)  //cette boucle permet de gerer la vitesse en divisant le temps du timer
		 if (V==j && a<=V){      
			bouger_curseur();
			w=gerage_balles(1);
			if (w==1){ 
                   gerage_bonus(); 
                   timer_superballe--;
                   timer_teleportation--;
                   timer_ballepourri--;
                   timer_finniveau--;
			}
		}
         if (a>=4) a=0;
		 
		 timer--;
		 if (oldtimer<=timer) break;
		 al_poll_duh(dp); //playing music
        }
		
		actualiser_map(); //draw updated blocks
		procedure_affichage();
		
        //if (key[KEY_V]) {changement_vitesse('+'); readkey();} 
        //if (key[KEY_L]) {changement_vitesse('-'); readkey();} 
        
        if  (key[KEY_ESC])
               {
               clear_bitmap(buffer);
               menu(1,0);        
               sortie=1;               
               }  
        
        
       if (nombre_de_balles_en_jeu()==0)
               {
               perte_vie();                   
               sortie=1;
               } 

if (NbrBriques<=2 && timer_finniveau<=0) timer_finniveau=4000;
if ((NbrBriques==0) || (NbrBriques<=2 && timer_finniveau<=1))
               {
               clear_bitmap(buffer);
               procedure_affichage();
               fin_niveau();                   
               sortie=1;
               } 
       }                        
    }                   
}

void preparation_jeu(char *niveau){
//itoa(Monentier,Monstring,10);     ou sprintf (encoremieux)
char *chemin_map;
chemin_map= malloc(sizeof(char)*50);
chemin_map[0]='\0';
strcat(chemin_map,"levels/level");
strcat(chemin_map,niveau);
strcat(chemin_map,".map");
if (!strcmp(niveau,"1"))
          {                
           switch(difficulte){
                              case 1:vies=6;break;
                              case 2:vies=4;break;
                              case 3:vies=2;break;
                             }
           score=0;                  
          }
          
     
clear_bitmap(buffer);    /*on prepare une nouvelle partie donc on efface le buffer*/
my_pic_x = ((taille_ecran_largeur )/2)-(largeur_curseur/2);
my_pic_y = 460;
largeur_curseur=80;
balle_en_attente=1;  /*On bloque la baballe tant que luser a pas appuy sur UP */
vider_bonus(); //On vide tous les bonus
destruction_balles();
creation_balle();
timer_superballe=0;
timer_teleportation=0;
timer_ballepourri=0;
timer_finniveau=0;
changement_vitesse(2);

     

if (charger_fichier_map(chemin_map)!=0) {
	   #ifdef DREAMCAST
	   acquire_screen();
	   #endif
       afficher_panneau();        
       textprintf_centre_ex(screen,grande_police, 280, 195,makecol(255,0,0), -1, "Jeu fini !!!");
       textprintf_centre_ex(screen,font, 280, 240,makecol(255,0,0), -1, "Appuyez sur la touche <Enter>");
       clear_keybuf();
	   #ifdef DREAMCAST
	   release_screen();
	   #endif
       while (!key[KEY_ENTER]){
		while (!keypressed())
		{
			if (musique==1) al_poll_duh(dp);
			rest(5);
		}
       readkey();
       }
       clear_bitmap(buffer);
       menu(0,1);
    }
free(chemin_map);
num_niv(niveau);
     

     
}


void placer_barre(void){
if(key[KEY_RIGHT] && position<(637-80)) 
		{ 
			position += 3;             
		} 
		else if(key[KEY_LEFT] && position>2) 
		{ 
			position -= 3 ;
        }
        
rectfill(buffer,0,445,640,465,makecol(0,0,0));     
rectfill(buffer, position, 445, position+80, 465, 235);
rectfill(buffer, position+2, 447, position+78, 463, makecol(160, 160, 160));
blit(buffer, screen, 0,0,0,0,640,480);
}
     
void perte_vie(){
     vies--;
     vider_bonus();
     if (vies!=-1) {
        jouer_son("son/verre-casse.wav");           
        balle_en_attente=1;
        largeur_curseur=80;
        destruction_balles();
        timer_superballe=0;
        timer_teleportation=0;
        timer_ballepourri=0;
        timer_finniveau=0;
        changement_vitesse(2);
        creation_balle();
        activation_jeu();
        }
     if (vies==-1) {
	   #ifdef DREAMCAST
	   acquire_screen();
	   #endif
       afficher_panneau();        
       textprintf_centre_ex(screen,grande_police, 280, 195,makecol(255,0,0), -1, "GAME OVER");
       textprintf_centre_ex(screen,font, 280, 240,makecol(255,0,0), -1, "Appuyez sur la touche <Enter>");
       //son du gameover 
       jouer_son("son/gameover.wav");
       clear_keybuf();
	   #ifdef DREAMCAST
	   release_screen();
	   #endif
       while (!key[KEY_ENTER]){
		while (!keypressed())
		{
			if (musique==1) al_poll_duh(dp);
			rest(5);
		}
       readkey();
       }
       clear_bitmap(buffer);
       menu(0,1);//on force le menu  safficher meme si c' est <enter> qui sest appuye
                  }
        
     }  
     
 void fin_niveau(){
      char temp[3];
	   #ifdef DREAMCAST
	   acquire_screen();
	   #endif
       afficher_panneau();
       textprintf_centre_ex(screen,font, 280, 200,makecol(255,0,0), -1, "Niveau Termin. Bravo !!!");
       textprintf_centre_ex(screen,font, 280, 220,makecol(255,0,0), -1, "Prt pour le suivant?");
       textprintf_centre_ex(screen,font, 280, 240,makecol(255,0,0), -1, "Appuyez sur <Enter> pour continuer");
       clear_keybuf();
	   #ifdef DREAMCAST
	   release_screen();
	   #endif
       while (!key[KEY_ENTER]){
	   while (!keypressed())
		{
			if (musique==1) al_poll_duh(dp);
			rest(5);
		}
       readkey();
       }
       clear_keybuf();
       sprintf (temp, "%d", num_level+1);
       preparation_jeu(temp);
       activation_jeu();
             
      }         
      
 void afficher_panneau(){
      DATAFILE *pan;
      pan = load_datafile_object("dynamique.dat", "pano");
      blit(pan->dat,screen,0,0,120,168,320,120);
      unload_datafile_object(pan);
      }     
